﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.Generic;

namespace XamWebDataChartSLApp.Model
{
    public class ChartViewModel : INotifyPropertyChanged
    {
        private bool _chartZoomed;
        public bool ChartZoomed
        {
            get { return _chartZoomed; }
            set
            {
                _chartZoomed = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(
                        this,
                        new PropertyChangedEventArgs("ChartZoomed"));
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class CustomDateTimeItemComparer : IComparer<object>
    {
        public int Compare(object x, object y)
        {
            DateTime xDate = DateTime.MinValue;
            DateTime yDate = DateTime.MaxValue;

            if (x is ChannelData)
            {
                xDate = (x as ChannelData).TimeStamp;
            }
            if (y is ChannelData)
            {
                yDate = (y as ChannelData).TimeStamp;
            }
            if (x is DateTime)
            {
                xDate = (DateTime)x;
            }
            if (y is DateTime)
            {
                yDate = (DateTime)y;
            }
            return DateTime.Compare(xDate, yDate);
        }
    }
}
