﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.Generic;

namespace XamWebDataChartSLApp.Model
{
    public class CurrentChannelData : INotifyPropertyChanged
    {
        private double? _value;

        public double? Value
        {
            get { return _value; }
            set
            {
                if ((this._value.Equals(value) != true))
                {
                    this._value = value;
                    this.RaisePropertyChanged("Value");
                }
            }
        }
        public string Name { get; set; }
        public int Index { get; set; }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            System.ComponentModel.PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
    }
    public class ChannelDataGroup
    {
        public int index { get; set; }
        public List<ChannelData> ChannelDataList { get; set; }
    }
    public class ChannelLookup
    {
        public int ChannelIndex { get; set; }
        public string ChannelName { get; set; }
        public string Units { get; set; }
        public int Min { get; set; }
        public int Max { get; set; }
    }
    public enum DataMode
    {
        Live,
        Historical
    }

    public partial class ChannelData : object, System.ComponentModel.INotifyPropertyChanged
    {
        private int ChannelIndexField;
        private System.DateTime TimeStampField;
        private System.Nullable<double> ValueField;

        public int ChannelIndex
        {
            get
            {
                return this.ChannelIndexField;
            }
            set
            {
                if ((this.ChannelIndexField.Equals(value) != true))
                {
                    this.ChannelIndexField = value;
                    this.RaisePropertyChanged("ChannelIndex");
                }
            }
        }

        public System.DateTime TimeStamp
        {
            get
            {
                return this.TimeStampField;
            }
            set
            {
                if ((this.TimeStampField.Equals(value) != true))
                {
                    this.TimeStampField = value;
                    this.RaisePropertyChanged("TimeStamp");
                }
            }
        }

        public System.Nullable<double> Value
        {
            get
            {
                return this.ValueField;
            }
            set
            {
                if ((this.ValueField.Equals(value) != true))
                {
                    this.ValueField = value;
                    this.RaisePropertyChanged("Value");
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            System.ComponentModel.PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
    }
    public partial class Viper : object, System.ComponentModel.INotifyPropertyChanged
    {
        private System.Collections.Generic.List<ChannelData> ChannelDataListField;
        private string SerialNumberField;
        private byte StatusField;
        private int ViperIdField;

        public System.Collections.Generic.List<ChannelData> ChannelDataList
        {
            get
            {
                return this.ChannelDataListField;
            }
            set
            {
                if ((object.ReferenceEquals(this.ChannelDataListField, value) != true))
                {
                    this.ChannelDataListField = value;
                    this.RaisePropertyChanged("ChannelDataList");
                }
            }
        }

        public string SerialNumber
        {
            get
            {
                return this.SerialNumberField;
            }
            set
            {
                if ((object.ReferenceEquals(this.SerialNumberField, value) != true))
                {
                    this.SerialNumberField = value;
                    this.RaisePropertyChanged("SerialNumber");
                }
            }
        }

        public byte Status
        {
            get
            {
                return this.StatusField;
            }
            set
            {
                if ((this.StatusField.Equals(value) != true))
                {
                    this.StatusField = value;
                    this.RaisePropertyChanged("Status");
                }
            }
        }

        public int ViperId
        {
            get
            {
                return this.ViperIdField;
            }
            set
            {
                if ((this.ViperIdField.Equals(value) != true))
                {
                    this.ViperIdField = value;
                    this.RaisePropertyChanged("ViperId");
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            System.ComponentModel.PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
