﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;

namespace XamWebDataChartSLApp.Model
{
    public class SeriesItemInfo : INotifyPropertyChanged
    {
        private Series _series;
        public Series Series
        {
            get { return _series; }
            set
            {
                _series = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Series"));
                }
            }
        }

        private object _item;
        public object Item
        {
            get { return _item; }
            set
            {
                _item = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Item"));
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
    public class SeriesItemInfoCollection : ObservableCollection<SeriesItemInfo>
    {
        public void UpdateSeriesItem(Series series, object item)
        {
            bool found = false;
            var indexes = from curr in this
                          where curr.Series.Title == series.Title
                          select this.IndexOf(curr);
            foreach (int index in indexes)
            {
                found = true;
                this[index].Item = item;
            }

            if (!found)
            {
                this.Add(new SeriesItemInfo()
                    {
                        Series = series,
                        Item = item
                    });
            }
        }
    }
}
